#line 1 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC16F886/DHT11/DHT11.c"
#line 13 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC16F886/DHT11/DHT11.c"
char GLCD_DataPort at PORTC;

sbit GLCD_CS1 at RB5_bit;
sbit GLCD_CS2 at RB4_bit;
sbit GLCD_RS at RB0_bit;
sbit GLCD_RW at RB1_bit;
sbit GLCD_RST at RB6_bit;
sbit GLCD_EN at RB2_bit;

sbit GLCD_CS1_Direction at TRISB5_bit;
sbit GLCD_CS2_Direction at TRISB4_bit;
sbit GLCD_RS_Direction at TRISB0_bit;
sbit GLCD_RW_Direction at TRISB1_bit;
sbit GLCD_RST_Direction at TRISB6_bit;
sbit GLCD_EN_Direction at TRISB2_bit;


sbit BackLight at RB3_bit;

sbit Data at RA0_bit;
sbit DataDir at TRISA0_bit;
char message1[] = "Temp = 00.0 C";
char message2[] = "RH   = 00.0 %";
unsigned short TOUT = 0, CheckSum, i;
unsigned short T_Byte1, T_Byte2, RH_Byte1, RH_Byte2;

void StartSignal(){
 DataDir = 0;
 Data = 0;
 Delay_ms(25);
 Data = 1;
 Delay_us(30);
 DataDir = 1;

}

unsigned short CheckResponse(){
 TOUT = 0;
 TMR2 = 0;
 T2CON.TMR2ON = 1;
 while(!Data && !TOUT);
 if (TOUT) return 0;
 else {
 TMR2 = 0;
 while(Data && !TOUT);
 if (TOUT) return 0;
 else {
 T2CON.TMR2ON = 0;
 return 1;
 }
 }
}

unsigned short ReadByte(){
 unsigned short num = 0, t;
 DataDir = 1;
 for (i=0; i<8; i++){
 while(!Data);
 TMR2 = 0;
 T2CON.TMR2ON = 1;
 while(Data);
 T2CON.TMR2ON = 0;
#line 79 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC16F886/DHT11/DHT11.c"
 if(TMR2 > 45) num |= 1<<(7-i);
 }
 return num;
}

void interrupt(){
 if(PIR1.TMR2IF){
 TOUT = 1;
 T2CON.TMR2ON = 0;
 PIR1.TMR2IF = 0;
 }
}

void main() {
 unsigned short check;
 ANSEL = 0;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 TRISB = 0;
 TRISA = 0x01;
 TRISC = 0;

 INTCON.GIE = 1;
 INTCON.PEIE = 1;

 PIE1.TMR2IE = 1;
 T2CON = 1;
 PIR1.TMR2IF =0;

 TMR2 = 0;
 Glcd_Init();
 Glcd_Fill(0x00);
 BackLight = 1;

 do {
 Delay_ms(2000);
 StartSignal();
 check = CheckResponse();
 if (!check) {
 Glcd_Fill(0x00);
 Glcd_Set_Font(Font_Glcd_Character8x7, 8, 7, 32);
 Glcd_Write_Text("DHT11 is not", 10, 3, 1);
 Glcd_Write_Text("responding!", 10, 5, 1);
 }
 else{

 RH_Byte1 = ReadByte();
 RH_Byte2 = ReadByte();
 T_Byte1 = ReadByte();
 T_Byte2 = ReadByte();
 CheckSum = ReadByte();

 if (CheckSum == ((RH_Byte1 + RH_Byte2 + T_Byte1 + T_Byte2) & 0xFF))
 {
 message1[7] = T_Byte1/10 + 48;
 message1[8] = T_Byte1%10 + 48;
 message1[10] = T_Byte2/10 + 48;
 message2[7] = RH_Byte1/10 + 48;
 message2[8] = RH_Byte1%10 + 48;
 message2[10] = RH_Byte2/10 + 48;

 Glcd_Fill(0x00);

 Delay_ms(50);
 Glcd_Set_Font(Font_Glcd_Character8x7, 8, 7, 32);
 Glcd_Write_Text(message1, 8, 2, 1);
 Glcd_Write_Text(message2, 8, 4, 1);
 Glcd_Set_Font(Font_Glcd_5x7, 5, 7, 32);
 Glcd_Write_Text("As measured by DHT11", 8, 6, 1);
 }

 else{
 Glcd_Fill(0x00);
 Glcd_Set_Font(Font_Glcd_Character8x7, 8, 7, 32);
 Glcd_Write_Text("Checksum error", 10, 3, 1);
 Glcd_Write_Text("Trying again ...", 10, 4, 1);

 }
 }

 }while(1);
}
